#include<iostream>
#include<vector>
using namespace std;
void solve(vector<int> v) {
	vector<int> ans;
	int n = v.size();
	ans.push_back(n-1);
	for(int i = 0; i <n-1; i++) ans.push_back(i);
	for(int i = 0; i < ans.size(); i++) cout << ans[i] <<" ";
	return;
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t ;
    for (int test=1; test<=t; test++) {
        int n;
        cin >> n ;
        vector <int> a(n);
        for (int i=0; i<n; i++) {
            cin >> a[i] ;
        }
        solve(a);
    }
    cout << endl ;
    return 0;
}

